// *********    YAMAHA THR10 Ampli   **********
// *             Preset 1 to 5                *
// *             Tuner (single press)         *
// *             AMP selector (UP and DOWN)   *
// *             Loop Fading Function         *
// *             OLED Display                 *
// ********************************************
 

#include <SoftwareSerial.h> 
SoftwareSerial SoftSerial(5, 6); // RX, TX

/***********************  MCP42XXX Commands  ************************/

#include <SPI.h>
const int CS_PIN = 10;
int potMax = 255;
int potValue = 0;
// int Count = 0;
int potIni = 0;
int Step = 1;                        // +1 pot increase (Fade-Out)   -1 pot decrease (Fade-In)
int reset = 0;
int latchSim = 0;                    // flag to simulate latching of the FADE footswitch


//potentiometer select byte
const int POT0_SEL = 0x11;
const int POT1_SEL = 0x12;
const int BOTH_POT_SEL = 0x13;

//shutdown the device to put it into power-saving mode.
//In this mode, terminal A is open-circuited and the B and W terminals are shorted together.
//to bypass the digital potentiometer

const int POT0_SHUTDOWN = 0x21;
const int POT1_SHUTDOWN = 0x22;
const int BOTH_POT_SHUTDOWN = 0x23;

/*********************************************************************/


int tmrCount = 0;  // COUNTER FOR A B CHANNELS ENCODER
int del = 120;     // timer for all
int tuner = 2000;  // timer for tuner: simulate the HOLD 
char c  = ' ';     // c=D Down - c=U Up - c=0 Tuner - c=1,2,3,4,5 Preset - c=6 Fade
byte A = 2;        // D2 BLUE   CHANNEL A
byte B = 3;        // D3 YELLOW CHANNEL B

void setup() 

{
    pinMode(LED_BUILTIN, OUTPUT);
    pinMode(A0, OUTPUT);          // Tuner
    pinMode(A1, OUTPUT);          // Preset 1
    pinMode(A2, OUTPUT);          // Preset 2
    pinMode(A3, OUTPUT);          // Preset 3
    pinMode(A4, OUTPUT);          // Preset 4
    pinMode(A5, OUTPUT);          // Preset 5
    pinMode(A, OUTPUT);           // D2 BLUE   CHANNEL A
    pinMode(B, OUTPUT);           // D3 YELLOW CHANNEL B

    pinMode(CS_PIN, OUTPUT);   // set the CS_PIN as an output:
    SPI.begin();     // initialize SPI:

    SoftSerial.begin(9600);
  //  Serial.begin(9600);  
  //  Serial.println("YAMAHA THR10 START");

    DigitalPotWrite(BOTH_POT_SEL , 0);
}
 

void loop() {

  if(SoftSerial.available())
  {
      char c = SoftSerial.read();
      reset = c;
    //  Serial.println(c);
      digitalWrite(LED_BUILTIN, HIGH);

        if (c=='U') {

    for (tmrCount = 0; tmrCount < 5;)
        {
                switch (tmrCount) {
                       case 0:
                       digitalWrite(A,HIGH);
                       break;
                       case 1:
                       digitalWrite(B,HIGH);
                       break;  
                       case 2:  
                       digitalWrite(A,LOW);
                       break;  
                       case 3: 
                       digitalWrite(B,LOW);
                                 }
          tmrCount++;
          delay(del);
        }
                      }

        if (c=='D') {

    for (tmrCount = 0; tmrCount < 5;)
        {
                switch (tmrCount) {
                       case 0:
                       digitalWrite(B,HIGH);
                       break;
                       case 1:
                       digitalWrite(A,HIGH);
                       break;  
                       case 2:  
                       digitalWrite(B,LOW);
                       break;  
                       case 3: 
                       digitalWrite(A,LOW);
                                 }
          tmrCount++;
          delay(del);
        }
                     }


        if (c<'D') {

                switch (c) {
                       case 48:
                       digitalWrite(A0,HIGH);
                       delay(tuner);
                       digitalWrite(A0,LOW);
                       break;  
                       case 49:  
                       digitalWrite(A1,HIGH);
                       delay(del); 
                       digitalWrite(A1,LOW);
                       break;
                       case 50:
                       digitalWrite(A2,HIGH);
                       delay(del);
                       digitalWrite(A2,LOW);
                       break;  
                       case 51:  
                       digitalWrite(A3,HIGH);
                       delay(del); 
                       digitalWrite(A3,LOW);
                       break;
                       case 52:
                       digitalWrite(A4,HIGH);
                       delay(del);
                       digitalWrite(A4,LOW);
                       break;  
                       case 53:  
                       digitalWrite(A5,HIGH);
                       delay(del); 
                       digitalWrite(A5,LOW);
                       break;
                       
                       case 54:  
                                // change the resistance on BOTH_POT from 0 to 255: VOL from MAX to min                         
                                   if(latchSim == 0)       {
                                       Step = 1; 
                                       latchSim = 1; 
                                       potIni = 0;         }
                               
                                // change the resistance on BOTH_POT from 255 to 0: VOL from min to MAX      
                                   else    {
                                            Step = -1;
                                            latchSim = 0;
                                            potIni = potMax; 
                                           }
                                       
                     for (potValue = potIni; potValue <= potMax  && potValue >= 0; potValue = potValue+Step) {
                              
                                    if(SoftSerial.available()) { char c = SoftSerial.read();
                                      
                                         if(c == 54 && latchSim == 1) { Step = -1; latchSim = 0; potIni = 0; }
                                         else { potValue = 0; reset = c; Step = -1; }
                                                       }
                        DigitalPotWrite(BOTH_POT_SEL , potValue);    
                        delay(50);                                                                           }

                           }
          digitalWrite(A0,HIGH);          // Tuner OFF
          delay(del);
          digitalWrite(A0,LOW);
          
 
          if(reset != 54) { DigitalPotWrite(BOTH_POT_SEL, 0);  latchSim = 0; potIni =0;}   // bypass digital potentiometer
          
        }
   }



digitalWrite(LED_BUILTIN, LOW);
}


// MCP42100
// send the command and the wiper value through SPI

void DigitalPotWrite(int cmd, int val)
{
  // constrain input value within 0 - 255
  val = constrain(val, 0, 255);
  // set the CS pin to low to select the chip:
  digitalWrite(CS_PIN, LOW);
  // send the command and value via SPI:
  SPI.transfer(cmd);
  SPI.transfer(val);
  // Set the CS pin high to execute the command:
  digitalWrite(CS_PIN, HIGH);
}
